#include "generator.h"
#include <sys/mman.h>
#include <stdio.h>
#include <stdlib.h>


static char letters[]="abcdefghijklmnopkrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";

struct Generator *generator_init(int number,int length){
  struct Generator *gen=NULL;
  int mlen = number*sizeof(char *) + number*(length+1) + sizeof(struct Generator);
  void *memory = mmap(NULL,mlen,PROT_READ|PROT_WRITE,MAP_PRIVATE|MAP_ANONYMOUS,0,0);
  if (memory==MAP_FAILED){
    perror("generator(mmap)");
    return NULL;
  }
  gen=memory;
  gen->mlen=mlen;
  gen->strings=(char **)((char *)memory+sizeof(struct Generator));
  char *s=(char *)memory+sizeof(struct Generator) + number*sizeof(char *);
  for(int i=0;i<number;++i){
    gen->strings[i]=s;
    for(int j=0;j<length;j++){
      *s = letters[random()%(sizeof(letters)-1)];
      s+=1;
    }
    *s='\0';
    s+=1;
  }
  return gen;
}

void generator_free(struct Generator *gen){
  if (gen!=NULL){
    munmap(gen,gen->mlen);
  }
}  

